/* eslint-disable no-undef */
// import request from '@/plugins/request'

export default {
  namespaced: true,
  state() {
    return {
      userInfo: uni.getStorageSync('userInfo') || {},
      code: uni.getStorageSync('code') || '',
      uid: uni.getStorageSync('uid') || '',
      accessToken: uni.getStorageSync('accessToken') || '',
    }
  },
  mutations: {
    setUserInfo(state, data) {
      uni.setStorageSync('userInfo', data)
      state.userInfo = data
    },
    setCode(state, data) {
      uni.setStorageSync('code', data)
      state.code = data
    },
    setUid(state, data) {
      uni.setStorageSync('uid', data)
      state.uid = data
    },
    setAccessToken(state, data) {
      uni.setStorageSync('accessToken', data)
      state.accessToken = data
    },
  },
  actions: {
    uniLogin({ commit }) {
      return new Promise((resolve, reject) => {
        uni.login({
          success(res) {
            commit('setCode', res.code)
            resolve()
          },
          fail() {
            commit('setCode', '')
            uni.showToast({
              title: '获取code失败，请稍后重试',
              icon: 'none',
            })
            reject()
          },
        })
      })
    },
    login({ commit }, { code, encryptedData, iv }) {
      return new Promise(async (resolve, reject) => {
        // TODO 调用登录接口，设置store数据
        resolve()
      })
    },
  },
}
