import request from '@/plugins/request'

// 埋点
export const setTrackData = ({ events = [], beforeEvent = null }) => {
  // 统一添加埋点字段 action_time
  events.forEach(item => {
    if (!item.action_time) {
      item.action_time = Date.now()
    }
  })
  // 埋点参数-前置事件，接口入参默认值
  const beforeEventDefault = {
    action_time: Date.now(),
    event_id: '',
    event_custom_properties: {
      part: '',
      position: '',
      element: '',
    },
  }

  return new Promise((resolve, reject) => {
    // 获取设备信息
    // eslint-disable-next-line no-undef
    uni.getSystemInfo({
      success(res) {
        // 发送埋点请求
        try {
          const result = request.post(
            '/dmp-event/v1/events/bulk',
            {
              app_name: '', // 应用名称，根据实际项目定义填写
              os_type: 4, // 操作系统类型，小程序
              time: Date.now(),
              os: res.system,
              os_version: res.version,
              model: res.model,
              screen_height: res.screenHeight,
              screen_width: res.screenWidth,
              wifi: res.wifiEnabled ? 1 : 0, // Wi-Fi 的系统开关
              manufacturer: '',
              ip: '',
              before_event: beforeEvent || beforeEventDefault,
              events,
            },
            {
              // 埋头中统一的请求头字段
              headers: {
                fid: res.deviceId,
                osType: 4,
                version: res.version,
                appName: 'ydllisten', // 应用名称
              },
            },
          )
          resolve(result)
        } catch (e) {
          reject(e)
        }
      },
      fail(res) {
        reject(res)
      },
    })
  })
}
